package cribbage;

public class Card implements Comparable {
    public enum Suit {CLUB,DIAMOND,HEART,SPADE};
    public enum Face {ACE,TWO,THREE,FOUR,FIVE,SIX,SEVEN,EIGHT,NINE,TEN,JACK,QUEEN,KING};
    
    private Suit suit;
    private Face face;
    
    public Card(Suit s,Face f) {
        suit = s;
        face = f;
    }
    
    public Suit getSuit() { return suit; }
    public Face getFace() { return face; }
    public int getPoints() { 
        if(face.ordinal() <= Face.TEN.ordinal())
            return face.ordinal() + 1; 
        else 
            return 10;
    }
    
    public String toString() {
        String[] names = {"Ace","2","3","4","5","6","7","8","9","10","Jack","Queen","King"};
        String[] suits = {"Clubs","Diamonds","Hearts","Spades"};
        return names[face.ordinal()] + " of " + suits[suit.ordinal()];
    }

    @Override
    public int compareTo(Object o) {
        Card other = (Card) o;
        int first = this.face.ordinal();
        int second = other.getFace().ordinal();
        if(first < second)
            return -1;
        else if(first > second)
            return 1;
        return 0;
    }
    
    
    public static void main(String[] args) {
        Card c = new Card(Suit.HEART,Face.QUEEN);
        System.out.println(c.toString() + " is worth " + c.getPoints() + " points.");
    }
}

