package cribbage.scoring;

import cribbage.Card;
import java.util.List;

public class RunScorer implements Scorer {

    @Override
    public int score(List<Card> cards) {
        boolean isRun = true;
        Card previous = null;
        for(Card c : cards) {
            if(previous != null)
               isRun = isRun && previous.getFace().ordinal() == (c.getFace().ordinal() - 1);
            previous = c;
        }
        if(!isRun || cards.size() < 3)
            return 0;
        if(cards.size() == 3)
            return 3;
        if(cards.size() == 4)
            return -2;
        return 0;
    }
    
    @Override
    public String what() {
        return "Run";
    }
}
