package cribbage.scoring;

import cribbage.Card;
import cribbage.Deck;
import cribbage.Hand;
import java.util.ArrayList;
import java.util.List;

public class ScoringTest {
    public static void main(String[] args) {
        Deck d = new Deck();
        Card[] h = new Card[5];
        for(int n = 0;n < 5;n++) {
            h[n] = d.deal();
        }
        Hand hand = new Hand(h);
        System.out.println("Hand");
        for(Card c : hand.allCards())
            System.out.println(c);
        
        List<Scorer> scorers = new ArrayList<Scorer>();
        scorers.add(new FifteenScorer());
        scorers.add(new PairScorer());
        scorers.add(new RunScorer());
        
        int points = 0;
        for(int n = 1;n < 32;n++) {
            List<Card> s = hand.subset(n);
            for(Scorer sc : scorers) {
                int scored = sc.score(s);
                points += scored;
                if(scored > 0) {
                    System.out.println();
                    System.out.println(sc.what() + ": " + scored);
                    for(Card c : s)
                        System.out.println(c);
                }
            }
        }
        FlushScorer f = new FlushScorer();
        int fs = f.score(hand.allCards());
        if(fs > 0) {
            points += fs;
            System.out.println("Hand is flush: " + fs);
        }
        
        System.out.println();
        System.out.println("Total points: " + points);
    }
}
